/* ===========================================================================
                      ITERATIVE TOWERS OF HANOI
It goes down "as j=j-2" (see below)
For this program see: Pettorossi, A.: "Towers of Hanoi problems: deriving
iterative solutions by program transformation BIT Vol.25 (1985), 327-334.
=========================================================================== */
#include  <iostream.h>
#include  <string>   // not <string.h>. File needed for using strings.
const int Initial=2; // it should be >=0
const int Final=3;   // it should be >=Initial
/*----------------------------------------------------------------------------
Initial and Final are the minimum and maximum number of disks for which the
sequences of moves are constructed.
--------------------------------------------------------------------------- */
string res; string TripleString[3];
bool even(int n) {return (n/2)*2==n;}

void main()
{for (int i=Initial; i<=Final; i++)
{if (i==0) {res=" ";} else
 if (i==1) {res=" AB";} else
    {int j=i-2;
     if (even(j)) {for (int m=0; m<3; m++) {TripleString[m]=" ";}}
     else {TripleString[0]=" AB ";
           TripleString[1]=" BC ";
           TripleString[2]=" CA ";};
    //--------------------------------------------------------------
     while (j>1) {string Temp[3];
     for (int m=0; m<3; m++) Temp[m]=TripleString[m];
     TripleString[0]=Temp[0]+"AC"+Temp[1]+"AB"+Temp[2]+"CB"+Temp[0];
     TripleString[1]=Temp[1]+"BA"+Temp[2]+"BC"+Temp[0]+"AC"+Temp[1];
     TripleString[2]=Temp[2]+"CB"+Temp[0]+"CA"+Temp[1]+"BA"+Temp[2];
                  j=j-2;};
    //--------------------------------------------------------------
     res=TripleString[0]+"AC"+TripleString[1]+"AB"+TripleString[2]
          +"CB"+ TripleString[0];};
 cout <<"Moves for Hanoi from peg A to peg B of "<<i<<" disks:\n";
 cout << res << "\n\n";}
}
/* input:   output:
------------------------------------------------------------------------------
            Moves for Hanoi from peg A to peg B of 2 disks:
             AC AB CB

            Moves for Hanoi from peg A to peg B of 3 disks:
             AB AC BC AB CA CB AB
--------------------------------------------------------------------------- */
